/*
  Exercice 11

  Ecrivez un programme dans lequel on cre une grille virtuelle de
  processus. Faites tourner une jeton sur les lignes et un sur les colonnes. Que
  ce passe-t-il si une des dimensions ne possde pas de liens retour?  
*/

#include <math.h>
#include <mpi.h>

void main(argv, argc)
     int argv; 
     char *argc[];
     
{
  int size,          /* nombre de processus                         */
    my_num_p,        /* mon numero avant                            */
    my_num_a,        /* mon numero apres                            */
    dims[2],         /* dimensions et nombre de procs ds chaque dim */
    periods[2],      /* periodes pour chaque dimension              */
    mycoords[2],     /* coordonnees dans la grille virtuelle        */
    sqrp,            /* racine carre du nombre de proc              */
    reorder;         /* re-arrangement des processus                */
  MPI_Comm new_comm; /* communicateur de la topologie cartesienne   */

 
  MPI_Init(&argv, &argc);
  
  MPI_Comm_rank(MPI_COMM_WORLD, &my_num_p);
  MPI_Comm_size(MPI_COMM_WORLD, &size);

  sqrp = (int)(sqrt((double)size));
  if (my_num_p == 0)
    printf("\nCreation d'une grille %dx%d\n\n", sqrp, sqrp);

  /*
  if (sqrp*sqrp != size) {
    printf("%d pas un nombre carre de procs, desole !\n", size);
    exit(1);
  }*/
  
  printf("Hello world from %d out of %d\n", my_num_p, size);
  
  /* 
   * Creation de la topologie cartesienne 
   */
  dims[0] = dims[1] = sqrp;  /* grille carre de sqrp*sqrp          */
  periods[0] = 1;            /* periode sur les colonnes           */
  periods[1] = 0;            /* pas de periode sur les lignes      */
  reorder = 1;               /* on re-arrange les numeros de procs */
  MPI_Cart_create(MPI_COMM_WORLD, 2, dims, periods, reorder, &new_comm);

  /*
   * recuperation des coordonnees dans le nouveau communicateur
   */
  if (new_comm != MPI_COMM_NULL) {
    MPI_Comm_rank(new_comm, &my_num_a);
    MPI_Cart_coords(new_comm, my_num_a, 2, mycoords);
    printf("Hello de %d (avt %d), coords (%d,%d)\n", my_num_a, my_num_p, 
	   mycoords[0], mycoords[1]);
  }
  else {
    printf("%d n'existe plus dans la nouvelle grille\n", my_num_p);
  }

  MPI_Finalize();
}
